# choose a docker image to use
image: node:14-buster

pages:
  # trigger deployment on every push to main branch
  only:
  - main

  variables:
    VUEPRESS_BASE: "/${CI_PROJECT_NAME}/" 

  environment:
    name: prod/gitpages
    url: $CI_PAGES_URL

  # cache node_modules
  cache:
    paths:
    - node_modules/

  # install dependencies and run build script
  script:
  - yarn --frozen-lockfile
  - yarn docs:build --dest public

  artifacts:
    paths:
    - public

preview:
  stage: deploy
  environment:
    name: dev/$CI_COMMIT_REF_SLUG
    url: "https://${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}.surge.sh"
  cache:
    paths:
    - node_modules/
  script:
    - yarn --frozen-lockfile
    - yarn docs:build --dest preview
    - node_modules/.bin/surge preview ${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}.surge.sh
  except:
    - main